<template>
  <div class="container">

    <div class="d-flex flex-row justify-content-between">
      <h4 class="recent-movies mt-4">Recent Movies</h4>
      
      <form @submit.prevent="getData" class="d-flex flex-row align-items-center mt-4 movie-search-box">
        <input type="text" class="movie-search form-control form-rounded mx-2" placeholder="Search..." v-model="query">
        <button type="submit" class="btn btn-success movie-search-button"><i class="bi bi-search"></i></button>
      </form>
    </div>

    <div class="movie-cards row">
      <!--  mt-4 mx-4 -->
      <div class="d-inline-flex justify-content-center col-lg-3 my-4" v-for="(movie, index) in customItems">

        <div class="card h-100 movie-card" v-on:click="openMovieDetails($event, movie)">
          <img class="card-img-top movie-image" :src="movie.image" alt="card image">
          
          <div class="card-body">
            <div class="d-flex justify-content-between align-items-center">
              <h5 class="card-title">{{ movie.name }}</h5>
              <div class="movie-rate d-flex align-items-center">
                <span class="mb-2">{{ movie.rate }}</span>
                <i class="bi bi-star-fill ml-2 movie-star"></i>
              </div>
            </div>
            <p class="card-text">{{ movie.description }}</p>
            <button v-on:click="addProductToCart(movie)" class="btn btn-primary">Details..</button>
          </div>

        </div>

      </div>
    </div>

  </div>
</template>

<script>
import axios from 'axios';

export default {

  data() {
    return {
      //define variables
      query: null,
      movies: []
    }
  },
  mounted() {
    //fired when page load
    this.getMovies();
  },
  computed: {
    customItems() {
      return this.movies.map(item => {
        if (item.description.length > 80) {
          return { ...item, description: item.description.substring(0, 80) + "..." }
        } else {
          return { ...item, description: item.description }
        }
      })
    }
  },
  methods: {
    //api call methods and other methods 
    getMovies() {
      axios.get('http://localhost:8000/api/movies', {
        headers: {
          'Authorization': localStorage.getItem('token'),
          'Accept': 'application/json'
        }
      }).then(res => {
        console.log(res.data);
        this.movies = res.data.data;
      });
    },

    openMovieDetails: function (event, movie) {
      // targetId = event.currentTarget.id;
      // console.log(targetId); // returns 'foo'
      this.$router.push({ path: `/movies/${movie.id}` });
    },

    async getData(){
      console.log(this.query);
      if(this.query==null||this.query==''){
        this.getMovies();
      }else{
        axios.get('http://localhost:8000/api/movies/search/' + this.query, {
          headers: {
            'Authorization': localStorage.getItem('token'),
            'Accept': 'application/json'
          }
        }).then(res => {
          console.log(res.data);
          this.movies = res.data.data;
        });
      }
    }
  },
}
</script>

<style>
[class^="bi-"]::before, [class*=" bi-"]::before{
  line-height: inherit!important;
}

.movie-search-box{
  margin-bottom: 8px;
}

.recent-movies {
  text-transform: uppercase;
  color: #fdba74;
}

.movie-search{
  border-radius:16px;
  height: 2rem;
  width: 19rem;
  text-indent: 50;
}

.movie-search-button{
  padding:.2rem;
  border-radius: 50%;
  width: 32px;
  height: 32px;
}

.movie-cards {
  padding-bottom: 3rem !important;
}

.movie-card {
  cursor: pointer !important;
  border-radius: 16px !important;
}

.movie-image {
  height: 350px;
  width: 270px;
  border-top-right-radius: 16px !important;
  border-top-left-radius: 16px !important;
}

.card-text {
  width: 238px;
  min-height: 10vh;
  max-height: 10vh;
  height: 10vh;
}

.movie-star {
  margin-left: .5rem;
  margin-bottom: 0.5rem;
  color: #fdba74;
}

.btn-primary,
.btn-primary:hover,
.btn-primary:focus-visible {
  background: #474646 !important;
  border-color: #474646 !important;
}

.movie-card:hover .movie-image{
  opacity: 0.8;
}

.movie-card:hover .btn-primary,
.btn-primary:hover,
.btn-primary:focus-visible{
  background: #157347 !important;
  border-color: #157347 !important;
}
</style>
